> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mangopay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# View a UBO

<Warning>
  **Caution – Legacy endpoints being superseded by the hosted KYC/KYB solution**

  Mangopay's [hosted KYC/KYB solution](/guides/users/verification/hosted) is becoming mandatory for all platforms, and allows Legal Users to declare and verify all beneficial owners in the same [IDV Session](/api-reference/idv-sessions/idv-session-object) object.

  The [criteria defining beneficial owners](/guides/glossary#beneficial-owner-ubo) remain the same.
</Warning>

### Path parameters

<ParamField path="UserId" type="string" required>
  The unique identifier of the user.
</ParamField>

<ParamField path="UboDeclarationId" type="string" required>
  The unique identifier of the UBO Declaration.
</ParamField>

<ParamField path="UboId" type="string" required>
  The unique identifier of the UBO.
</ParamField>

### Responses

<AccordionGroup>
  <Accordion title="200">
    <ResponseField name="Id" type="string">
      Max length: 128 characters (see [data formats](/api-reference/overview/data-formats) for details)

      The unique identifier of the object.
    </ResponseField>

    <ResponseField name="CreationDate" type="Unix timestamp">
      The date and time at which the object was created.
    </ResponseField>

    <ResponseField name="LastName" type="string">
      Max. length: 100 characters

      The last name of the beneficial owner.
    </ResponseField>

    <ResponseField name="FirstName" type="string">
      Max. length: 100 characters

      The first name of the beneficial owner.
    </ResponseField>

    <ResponseField name="Birthday" type="Unix timestamp">
      The date of birth of the beneficial owner.

      **Note:** This is a Unix timestamp in UTC. Ensure you convert your timezone to UTC to avoid midnight being interpreted as the day before.
    </ResponseField>

    <ResponseField name="Nationality" type="string">
      The nationality of the beneficial owner.
    </ResponseField>

    <ResponseField name="Address" type="object">
      The postal address of the beneficial owner.

      <Expandable title="properties">
        <ResponseField name="AddressLine1" type="string">
          Max. length: 255 characters

          The first line of the address.
        </ResponseField>

        <ResponseField name="AddressLine2" type="string">
          Max. length: 255 characters

          The second line of the address.
        </ResponseField>

        <ResponseField name="City" type="string">
          Max. length: 255 characters

          The city of the address.
        </ResponseField>

        <ResponseField name="Region" type="string">
          Max. length: 255 characters

          The region of the address. This field is optional except if the `Country` is US, CA, or MX.
        </ResponseField>

        <ResponseField name="PostalCode" type="string">
          Max. length: 255 characters

          The postal code of the address. The postal code can contain the following characters: alphanumeric, dashes, and spaces.
        </ResponseField>

        <ResponseField name="Country" type="string">
          Format: Two-letter country code ([ISO 3166-1 alpha-2 format](/api-reference/overview/data-formats))

          The country of the address.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="Birthplace" type="object">
      Information about the beneficial owner's place of birth.

      <Expandable title="properties">
        <ResponseField name="City" type="string">
          The city in which the beneficial owner was born.
        </ResponseField>

        <ResponseField name="Country" type="string">
          Format: Two-letter country code ([ISO 3166-1 alpha-2 format](/api-reference/overview/data-formats))

          The country in which the beneficial owner was born.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="IsActive" type="boolean">
      Whether or not the UBO is considered in the declaration. To disregard a UBO, this parameter must be set to `false`. This action is irreversible.
    </ResponseField>
  </Accordion>
</AccordionGroup>

<ResponseExample>
  ```json 200 theme={null}
  {
      "Id": "ubo_m_01JH7TS5ZHW3R501ACJEKD5G39",
      "CreationDate": 1736503498,
      "LastName": "Wiza",
      "FirstName": "Jess",
      "Birthday": 652117514,
      "Nationality": "FR",
      "Address": {
          "AddressLine1": "669 Ratke Forge",
          "AddressLine2": "Schamberger Walk",
          "City": "Paris",
          "Region": "Île-de-France",
          "PostalCode": "75001",
          "Country": "FR"
      },
      "Birthplace": {
          "City": "Paris",
          "Country": "FR"
      },
      "IsActive": true
  }  
  ```
</ResponseExample>

<RequestExample>
  ```php PHP theme={null}
  <?php 

  require_once 'vendor/autoload.php';

  use MangoPay\MangoPayApi;
  use MangoPay\Libraries\ResponseException as MGPResponseException;
  use MangoPay\Libraries\Exception as MGPException;

  $api = new MangoPayApi();

  $api->Config->ClientId = 'your-client-id';
  $api->Config->ClientPassword = 'your-api-key';
  $api->Config->TemporaryFolder = 'tmp/';

  try {
      $userId = '198557165';
      $uboDeclarationId = '198692872';
      $uboId = '198693429';

      $response = $api->UboDeclarations->GetUbo($userId, $uboDeclarationId, $uboId);

      print_r($response);
  } catch(MGPResponseException $e) {
      print_r($e);
  } catch(MGPException $e) {
      print_r($e);
  }  
  ```

  ```javascript NodeJS   theme={null}
  const mangopayInstance = require('mangopay4-nodejs-sdk')
  const mangopay = new mangopayInstance({
    clientId: 'your-client-id',
    clientApiKey: 'your-api-key',
  })

  let myUser = {
    Id: '170853400',
  }

  let myUboDeclaration = {
    Id: '180932134',
  }

  let myUbo = {
    Id: '180945113',
  }

  const getUbo = async (userId, uboDeclarationId, uboId) => {
    return await mangopay.UboDeclarations.getUbo(userId, uboDeclarationId, uboId)
      .then((response) => {
        console.info(response)
        return response
      })
      .catch((err) => {
        console.log(err)
        return false
      })
  }

  getUbo(myUser.Id, myUboDeclaration.Id, myUbo.Id)  
  ```

  ```ruby Ruby   theme={null}
  require 'mangopay'

  MangoPay.configure do |client|
      client.preproduction = true
      client.client_id = 'your-client-id'
      client.client_apiKey = 'your-api-key'
      client.log_file = File.join(Dir.pwd, 'mangopay.log')
  end

  def viewUbo(legalUserId, uboDeclarationId, uboId)
      begin
          response = MangoPay::Ubo.fetch(legalUserId, uboDeclarationId, uboId)
          puts response
          return response
      rescue MangoPay::ResponseError => error
          puts "Failed to fetch UBO: #{error.message}"
          puts "Error details: #{error.details}"
          return false
      end
  end

  myLegalUser = {
      Id: '194338122'
  }

  myUboDeclaration = {
      Id: '194511216'
  }

  myUbo = {
      Id: '194511740'
  }

  viewUbo(myLegalUser[:Id], myUboDeclaration[:Id], myUbo[:Id])  
  ```

  ```java Java   theme={null}
  import com.google.gson.Gson;
  import com.google.gson.GsonBuilder;
  import com.mangopay.MangoPayApi;
  import com.mangopay.entities.Ubo;

  public class ViewUbo {
       public static void main(String[] args) throws Exception {
          MangoPayApi mangopay = new MangoPayApi();
          mangopay.getConfig().setClientId("your-client-id");
          mangopay.getConfig().setClientPassword("your-api-key");

          String userId = "user_m_01HRS7PQEGE4YGCM1AZK1ENTGE";
          String uboDeclarationId = "ubo_m_01HRYRKZN51BFXDWD6CCE22PHN";
          String uboId = "ubo_m_01HRYTZJS07SP4GAMKYMB9YPCG";

          Ubo viewUbo = mangopay.getUboDeclarationApi().getUbo(userId, uboDeclarationId, uboId);

          Gson prettyPrint = new GsonBuilder().setPrettyPrinting().create();
          String prettyJson = prettyPrint.toJson(viewUbo);

          System.out.println(prettyJson);
      }
  }
  ```

  ```python Python   theme={null}
  from pprint import pprint
  import mangopay

  mangopay.client_id='your-client-id'
  mangopay.apikey='your-api-key'

  from mangopay.resources import Ubo, UboDeclaration, LegalUser

  legal_user = LegalUser(
      id = '210602889'  
  )

  user_ubo_declaration = UboDeclaration(
      id = '210896999'
  )

  user_ubo = Ubo(
      id = '210898223'
  )

  try:
      view_ubo = Ubo.get(reference = user_ubo.id, user_id = legal_user.id, ubo_declaration_id = user_ubo_declaration.id) 
      pprint(vars(view_ubo))
  except Ubo.DoesNotExist:
      print('The UBO {} does not exist.'.format(user_ubo_declaration))  
  ```

  ```csharp .NET  theme={null}
  using MangoPay.SDK;
  using Newtonsoft.Json;

  class Program
  {
      static async Task Main(string[] args)
      {
          MangoPayApi api = new MangoPayApi();

          api.Config.ClientId = "your-client-id";
          api.Config.ClientPassword = "your-api-key";

      
          var userId = "user_m_01J2V0P9B1WCX46GEBDWCTXNQ0";
          var uboDeclarationId = "ubo_m_01J2V64AD2C8G7PYACCP16ZS74";
          var uboId = "ubo_m_01J2VBGYNQY07HYJQHKAS00VF8";

          var viewUbo = await api.UboDeclarations.GetUboAsync(userId, uboDeclarationId, uboId);

          string prettyPrint = JsonConvert.SerializeObject(viewUbo, Formatting.Indented);
          Console.WriteLine(prettyPrint);
      }
  }
  ```
</RequestExample>
